import torch 

def makeTensor(dim: tuple[int], value_type:str) -> torch.tensor:
    """ Returns a tensor of zeros, ones, or random floats [0, 1) of shape dim
        Args: 
            dim (tuple[int]): Dimensions in a tuple (e.g., (1, 3))
            value_type (str): Desired values, either all zeros ('zeros'), all
                                ones ('ones'), or random floats ('randoms')
        Returns:
            torch.tensor: tensor of desired values of shape dim
    """ 
    raise NotImplementedError

def reshapeTensor() -> None: 
    """ Prints three versions of the provided tensor

    1. Data all in one column (shape (6, 1))
    2. Data all in one row (shape (1, 6))
    3. Added a empty dimension in the middle (2, 1, 3)
    """
    A = torch.tensor([[1., 2., 3.], 
                      [4., 5., 6.]])

def indexTensor() -> None: 
    """ Prints three parts of the provided tensor using only indexing

    1. 5
    2. [2, 5, 8]
    3. [7, 8, 9]
    4. [[1, 2], 
        [4, 5], 
        [7, 8]]
    """
    A = torch.tensor([[1., 2., 3.], 
                      [4., 5., 6.], 
                      [7., 8., 9.]])

def sumTensor() -> None:
    """ Prints the
    [6, 15, 24] using only A and sum
    """
    A = torch.tensor([[1., 2., 3.], 
                      [4., 5., 6.], 
                      [7., 8., 9.]])
